
// Counters for kira:

typedef unsigned long step_t;

class kira_counters {
  public:

    real cpu_time;		  // CPU time since this process started
    real total_cpu_time;	  // total CPU time for the entire calculation

    step_t step_top_single;	  // top-level single steps
    step_t step_top_cm;		  // top-level CM steps
    step_t step_low_level;	  // low-level steps
    step_t force_correction;	  // force corrections

    step_t pert_step;		  // low-level perturbed steps
    step_t pert_with_list;	  // low-level *interparticle force*
    				  // calculations using perturber list
    step_t pert_without_list;	  // low-level *force* calculations
				  // without perturber list
    step_t perturber_overflow;	  // perturber list overflows

    step_t full_unpert_step;	  // full unperturbed steps
    step_t full_unpert_orbit;	  // full unperturbed orbits
    step_t partial_unpert_orbit;  // partial unperturbed orbits

    step_t tree_change;		  // changes in tree structure

    step_t top_level_combine;	  // top-level combines within tree structure
    step_t low_level_combine;	  // low-level combines within tree structure
    step_t top_level_split;	  // top-level splits within tree structure

    step_t leaf_merge;		  // physical mergers between stars

    real dm_escapers;		  // total mass loss in escaping stars (>0)
    real dm_massloss;		  // total mass loss by stellar evolution (>0)

    real initial_etot;		  // total energy at t = 0
    real de_total;		  // total energy change (subdivisions follow)
    real de_merge;		  // energy change due to mergers
    real de_massloss;		  // energy change due to stellar mass loss
    real de_kick;		  // energy change due to supernovae kicks

  kira_counters () {
         cpu_time=total_cpu_time=0;

         step_top_single     =
	 step_top_cm          = 
	 step_low_level        = 
	 force_correction       = 
	 pert_step               = 
	 pert_with_list           = 
	 pert_without_list         = 
	 perturber_overflow         = 
	 full_unpert_step            = 
	 full_unpert_orbit            = 
	 partial_unpert_orbit          = 
	 tree_change                    = 
	 top_level_combine               = 
	 low_level_combine                = 
	 top_level_split                   = 
	 leaf_merge                         =  0;

	 dm_escapers   =
	 dm_massloss    =
	 de_kick         =
	 de_massloss      =
	 de_merge          =
	 de_total           =
	 initial_etot        =  0;
  }
  
};
