/*
 *    star_to_kira.h: transformation function from stellar evolution
 *		      package to dynamical package.
 *
 *.....................................................................
 *    version 1:  Aug 1996   Simon F. Portegies Zwart
 *    version 2:
 *...................................................................
 *     This file includes:
 *  1) Transformation routines from stellar evolution to n-body dynamcs.
 *
 *....................................................................
 */

#ifndef     _DSTAR_TO_KIRA
#   define  _DSTAR_TO_KIRA

//#include  "starbase.h"
#include  "hdyn.h"

//#include "stdinc.h"
//#include "constants.h"

//#include "double_star.h"
#include "dstar_to_dyn.h"

/*-----------------------------------------------------------------------------
 *  dstar_to_hdyn  --  
 *-----------------------------------------------------------------------------
 */

bool binary_is_merged(dyn* bi);
bool create_or_delete_binary(hdyn*, bool*,
			     real eps=-1,
			     real eta=-1,
			     real dt_max=-1);
bool binary_evolution(hdyn* bi, real eps, real eta, real max_timestep);
void update_kepler_from_binary_evolution(hdyn*, real);

#endif          // _DSTAR_TO_KIRA




