
/* Check_dep:  Check whether the first file listed on the command line
 *   	       is older (return 1 as exit status) or younger (return 0)
 *	       than any of the other files listed.
 *
 *	       NOTE: Return 0 (i.e. do nothing) if the first file does not
 *		     exist, or if any other unrecoverable error occurs..
 */

#include <stdio.h>
#include <sys/stat.h>
#include <unistd.h>

void quit(int i)
{
  printf("%d\n", i);
  exit(0);
}

main(int argc, char* argv[])
{
  struct stat buf;
  unsigned long source_date;    /* Avoid use of time_t, as some UNICES
                                   don't understand it. */
  int i;

  if (argc < 3) quit(0);
  if (stat(argv[1], &buf) != 0) quit(0);
  source_date = (unsigned int) buf.st_ctime;

  for (i = 2; i < argc; i++) {
    if (stat(argv[i], &buf) == 0)
      if (buf.st_ctime > source_date) quit(1);
  }
  quit(0);

}
