
       //=======================================================//    _\|/_
      //  __  _____           ___                    ___       //      /|\
     //  /      |      ^     |   \  |         ^     |   \     //          _\|/_
    //   \__    |     / \    |___/  |        / \    |___/    //            /|\
   //       \   |    /___\   |  \   |       /___\   |   \   // _\|/_
  //     ___/   |   /     \  |   \  |____  /     \  |___/  //   /|\     
 //                                                       //            _\|/_
//=======================================================//              /|\

// The following macros control most of the diagnostic output coming
// from the dynamical integration routines in kira.
//
// Recommended defaults are indicated [in square brackets].

//------------------------------------------------------------------------
// Top-level (kira.C):

#define DEBUG_MAIN				false		// [false]

//------------------------------------------------------------------------
// Unperturbed motion (hdyn_unpert.C):

#define REPORT_START_UNPERTURBED        	true		// [true]
#define REPORT_CONTINUE_UNPERTURBED		false		// [false]
#define REPORT_END_UNPERTURBED			true		// [true]
#define REPORT_PERICENTER_REFLECTION		false		// [false]
#define REPORT_IMPENDING_MULTIPLE_STATUS	false		// [false]
#define REPORT_ZERO_UNPERT_STEPS		false		// [false]
#define REPORT_MULTIPLE				true		// [true]

#define UNPERT_REPORT_LEVEL			0		// [0]
#define END_UNPERT_REPORT_LEVEL			0		// [0]

#define UNPERT_FUNCTION_ID			false		// [false]

// Note:  constructs such as the following are legal, as all of the
//	  above macros are only used in member functions:
//
// #define UNPERT_FUNCTION_ID	(system_time > 100 && system_time < 101)

//------------------------------------------------------------------------
// Tree maintenance (hdyn_tree.C):

#define DEBUG_TREE				true		// [true]
#define TREE_DEBUG_LEVEL			0		// [0]

//------------------------------------------------------------------------
// Force evaluation (hdyn_ev.C):

#define DEBUG_EV				false		// [false]
#define EV_FUNCTION_ID				false		// [false]
#define HARP_DEBUG				true		// [true]

//------------------------------------------------------------------------
// Force evaluation (kira_ev.C):

#define DEBUG_KIRA_EV				false		// [false]

//------------------------------------------------------------------------
// Stellar evolution (kira_stellar.C):

#define REPORT_STELLAR_EVOLUTION		false		// [false]
#define REPORT_STELLAR_MASS_LOSS		false		// [false]
#define REPORT_BINARY_MASS_LOSS			false		// [false]
