local void dump_node(hdyn* b)
{
    // Incomplete dump of hdyn data.

    cerr << endl;
    cerr.precision(16);

    PRL(b->format_label());
    PRL(b->get_time());
    PRL(b->get_timestep());
    PRL(b->get_unperturbed_timestep());
    PRL(b->get_pos());
    PRL(b->get_vel());
    PRL(b->get_acc());
    PRL(b->get_jerk());
    if (b->get_kepler())
	b->get_kepler()->print_all(cerr);

    cerr.precision(PRECISION);
}

local void dump_binaries(hdyn* b)
{
    for_all_daughters(hdyn, b, bb)
	if (bb->get_oldest_daughter())
	    for_all_nodes(hdyn, bb, bbb)
		dump_node(bbb);
}


// Sample debugging lines to precede integrate_list() in evolve_system.


#if 0
	for (int i = 0; i < n_next; i++) {
	    hdyn* n = next_nodes[i];
	    if (n->is_parent() || n->is_low_level_leaf()) {
		PRL(t);
		n->print_label(cerr);
		dump_node(n);
	    }
	}
#endif

#if 0
	for (int i = 0; i < n_next; i++) {
	    if (next_nodes[i]) {
		hdyn* bi = next_nodes[i];
		if (bi->get_top_level_node()->is_parent()) {
		    cerr << endl;
		    cerr << "evolve_system: integration list contains "
			 << bi->format_label() << endl;
		}
	    }
	}
#endif


//------------------------------------------------------------------------

// Sample debugging lines to follow integrate_list() in evolve_system.

#if 0
	for (int j = 0; j < n_next; j++) {
	    hdyn* n = next_nodes[j];
	    if (n && n->is_valid()) {
		if (node_contains(n->get_top_level_node(), "13a")) {
		    if (n->is_top_level_node())
			count0++;
		    hdyn* p = n->get_parent();
		    if (p->is_top_level_node())
			count1++;
		    hdyn* pp = p->get_parent();
		    if (pp && pp->is_top_level_node())
			count2++;
		    if ((count0+count1+count2)%1000 == 0) {
			cerr << "counts:  " << count0 << "  " << count1
			     << "  " << count2 << "  " << count_ << "  ";
			PRC(steps); PRL(cpu_time());
		    }
		} else
		    count_++;
	    }
	}
#endif


#if 0
 	if (t > 18.999) {
 	    cerr << endl; PRC(t); PRL(n_next);
	    for (int j = 0; j < n_next; j++) {
		hdyn* n = next_nodes[j];
		if (n && n->is_valid()) {
		    cerr << n->format_label() << ":  ";
		    if (n->is_low_level_node())
			n->print_perturber_list(cerr);
		    pp3(n, cerr);
		}
	    }
	    print_recalculated_energies(b, eps * eps);
 	}
	if (t > 19.1) exit(0);
#endif


#if 0
	if (t > 0.46) {

	    cerr << endl, PRC(t);
	    cerr << "evolve_system: after integrate_list:";

	    for (int i = 0; i < n_next; i++) {
		hdyn* bi = next_nodes[i];
		cerr << endl << "    ";
		cerr << bi->format_label();
		if (bi->is_top_level_node())
		    cerr << " (t";
		else
		    cerr << " (l";
		if (bi->is_leaf())
		    cerr << "l";
		else
		    cerr << "n";
		if (bi->get_kepler())
		    cerr << "u";
		else
		    cerr << "p";
		cerr << "), nn = ";
		if (bi->get_nn())
		    cerr << bi->get_nn()->format_label();
		else
		    cerr << "(nil)";
		if (bi->get_top_level_node()->is_parent()) {
		    cerr << endl;
		    pp3(bi->get_top_level_node(), cerr);
		}
	    }
	    cerr << endl;
	    print_recalculated_energies(b, eps * eps);

	} else {

	    for (int i = 0; i < n_next; i++) {
		if (next_nodes[i]) {
		    hdyn* bi = next_nodes[i];
		    if (bi->get_top_level_node()->is_parent()) {
			cerr << endl;
			cerr << "evolve_system: pp3 triggered by "
			     << bi->format_label() << endl;
			pp3(bi->get_top_level_node(), cerr);
		    }
		}
	    }

	}
#endif


#if 0
	for (int i = 0; i < n_next; i++) {
	    if (next_nodes[i] != NULL) {
		char c[128];
		real dt = next_nodes[i]->get_timestep();
		int idt = (int)(log(1.0/dt)/log(2.0) + .1);
		sprintf(c, "time = %.14f, new timestep = %.14f = 2^-%d",
			t, dt, idt);
		next_nodes[i]->log_comment(c);
	    }
	}
#endif

