
//// mkwrite:  Turn a text file into a snapshot.  Used in some
////           demostrations only.
////
//// Options:  -c    add a comment to the output snapshot [false]
////
//// Example:  /usr/games/banner -w 40 STARLAB | mkwrite -c "STARLAB"

#include "dyn.h"
#include <ctype.h>

#ifdef TOOLBOX

#define  MASS_SCALE_FACTOR     0.01
#define  LENGTH_SCALE_FACTOR   0.1
#define  LEFT_OFFSET         -20
#define  TOP_OFFSET            5

main(int argc, char ** argv)
    {
    bool  c_flag = FALSE;
    char  *comment;

    check_help();
 
    extern char *poptarg;
    int c;
    char* param_string = "c:";

    while ((c = pgetopt(argc, argv, param_string)) != -1)
	switch(c)
	    {
	    case 'c': c_flag = TRUE;
		      comment = poptarg;
		      break;
            case '?': params_to_usage(cerr, argv[0], param_string);
	              get_help();
                      exit(1);
	    }            
    
    dyn *b, *by, *bo;
    b = new dyn();
    bo = new dyn();
    b->set_oldest_daughter(bo);
    bo->set_parent(b);

    int  i = TOP_OFFSET;
    int  j = LEFT_OFFSET;

    c = getchar();
    while(c != EOF)
	{
	while (c != '\n' && c != EOF)
	    {
	    if (!isspace(c))
		{
		bo->set_mass(MASS_SCALE_FACTOR);
		bo->set_pos(vector(j*LENGTH_SCALE_FACTOR,
				   i*LENGTH_SCALE_FACTOR, 0));
		bo->set_vel(vector(0));
		by = new dyn();
		bo->set_younger_sister(by);
		by->set_elder_sister(bo);
		bo = by;
		}
	    j++;
	    c = getchar();
	    }
	i--;
	j = LEFT_OFFSET;
	if (c != EOF)
	    c = getchar();
	}

    bo = bo->get_elder_sister();
    delete by;
    bo->set_younger_sister(NULL);
    
    if (c_flag == TRUE)
        b->log_comment(comment);
    b->log_history(argc, argv);

    b->to_com();
    put_node(cout, *b);
    }

#endif

/* end of: mkwrite.c */
