
//// dumbp:  dump out an N-body system in a dumb format suitable
////         for digestion by NBODY1-5
////
//// Options: none

#include "dyn.h"

#ifdef TOOLBOX

main(int argc, char** argv)
{
    dyn *root, *ni;

    check_help();

    root = get_dyn(cin);
    for (ni = root->get_oldest_daughter(); ni != NULL;
         ni = ni->get_younger_sister()) {
#ifdef BAD_GNU_IO
         printf("%.6f ", ni->get_mass());
         vector temp;
         temp = ni->get_pos();
         int k;
         for (k = 0; k < 3; k++) printf("%.12f ",temp[k]);
         temp = ni->get_vel();
         for (k = 0; k < 3; k++) printf("%.12f ",temp[k]);
         printf("\n");
#else
	cout << ni->get_mass() << " " << ni->get_pos() << " "
				      << ni->get_vel() << endl;
#endif
     }
}

#endif

// end of: dumbp.C
