
//// dyn_io:  test Starlab dyn class I/O functions.
////
//// Options: none

#include "dyn.h"
#include "util_io.h"

#ifndef TOOLBOX

// Initialize all static dyn data here (?)

real dyn::system_time           = 0.0;
bool dyn::use_sstar	        = false;

istream & dyn::scan_dyn_story(istream& s)
{
    char input_line[MAX_INPUT_LINE_LENGTH];

    while (get_line(s,input_line), strcmp(")Dynamics",input_line)) {

	char keyword[MAX_INPUT_LINE_LENGTH];
	char should_be_equal_sign[MAX_INPUT_LINE_LENGTH];

	sscanf(input_line,"%s%s", keyword, should_be_equal_sign);

	if(strcmp("=",should_be_equal_sign)){
	    cerr << "Expected '=', but got '" << should_be_equal_sign << "'\n";
	    exit(1);
	}

    	if(0){   // trick to keep the if() statement, for the else below
    	    }else if(!strcmp("system_time",keyword)){
		sscanf(input_line,"%*s%*s%lf",&system_time);
    	    }else if(!strcmp("m",keyword)){
		sscanf(input_line,"%*s%*s%lf",&mass);
	    }else if(!strcmp("r",keyword)){
		set_vector_from_input_line(pos, input_line);
	    }else if(!strcmp("v",keyword)){
		set_vector_from_input_line(vel, input_line);
	    }else{
		add_story_line(dyn_story, input_line);
	    }
	}
    return s;
}

ostream& dyn::print_dyn_story(ostream& s)
{
    put_story_header(s, "Dynamics");

    if (!parent) put_real_number(s, "  system_time  =  ", system_time);
    put_real_number(s, "  m  =  ", mass);
    put_real_vector(s, "  r  =  ", pos);
    put_real_vector(s, "  v  =  ", vel);

    if (dyn_story)
	{
	if (kep)
	    kep->kep_to_dyn_story(dyn_story);          // redundant information
        put_story_contents(s, *dyn_story);
	}

    put_story_footer(s, "Dynamics");
    
    return s;
}

#else
main(int argc, char** argv)
{
    dyn  * b;
    check_help();

    while (b = (dyn *) get_node(cin, new_dyn)){
	cout << "TESTING put_dyn:" << endl;
        put_node(cout,*b);
	cout << "TESTING pp2()   :" << endl;
	pp2(b);
	delete b;
    }
    cerr << "Normal exit\n";
}
#endif
