
//// energy:  Print out the energy of an N-body system.
////
//// Options:   -e    specify softening parameter [0]

#include "dyn.h"

#ifdef TOOLBOX

main(int argc, char **argv)
{
    dyn *root;
    int  e_flag = 0;
    real eps = 0;

    check_help();

    extern char *poptarg;
    int c;
    char* param_string = "e:";

    while ((c = pgetopt(argc, argv, param_string)) != -1)
	switch(c) {
	    case 'e': e_flag = 1;
                      eps = atof(poptarg);
	              break;
            case '?': params_to_usage(cerr, argv[0], param_string);
	              get_help();
                      exit(1);
	}

    // Loop over input until no more data remain.

    while ( (root = get_dyn(cin)) != NULL) {

	real kinetic_energy, potential_energy;
	get_energies(root, eps, kinetic_energy, potential_energy);

	cout << "Energies (T, U, E):  " << kinetic_energy << "  "
                                        << potential_energy << "  "
                                        << kinetic_energy + potential_energy 
                                        << endl;
    }
}

#endif

// endof: energy.C
